# -*- coding: UTF-8-*-
# ClockToText italian version
# modded by Black Hole Team
# capa All_In_One Mod - DE, IT, ES, NL, FR, PT, RU
from Converter import Converter
from time import localtime, strftime
from Components.Element import cached
from Components.config import config

class ClockToText(Converter, object):
	DEFAULT = 0
	WITH_SECONDS = 1
	IN_MINUTES = 2
	DATE = 3
	FORMAT = 4
	AS_LENGTH = 5
	TIMESTAMP = 6
	
	# add: date, date as string, weekday, ... 
	# (whatever you need!)
	
	def __init__(self, type):
		Converter.__init__(self, type)
		if type == "WithSeconds":
			self.type = self.WITH_SECONDS
		elif type == "InMinutes":
			self.type = self.IN_MINUTES
		elif type == "Date":
			self.type = self.DATE
		elif type == "AsLength":
			self.type = self.AS_LENGTH
		elif type == "Timestamp":	
			self.type = self.TIMESTAMP
		elif str(type).find("Format") != -1:
			self.type = self.FORMAT
			self.fmt_string = type[7:]
		else:
			self.type = self.DEFAULT

	@cached
	def getText(self):
		time = self.source.time
		if time is None:
			return ""

		# handle durations
		if self.type == self.IN_MINUTES:
			return "%d min" % (time / 60)
		elif self.type == self.AS_LENGTH:
			return "%d:%02d" % (time / 60, time % 60)
		elif self.type == self.TIMESTAMP:
			return str(time)
		
		t = localtime(time)
		
		if self.type == self.WITH_SECONDS:
			return "%2d:%02d:%02d" % (t.tm_hour, t.tm_min, t.tm_sec)
		elif self.type == self.DEFAULT:
			return "%02d:%02d" % (t.tm_hour, t.tm_min)
		elif self.type == self.DATE:
			backstring = strftime("%A %B %d, %Y", t)
			if config.osd.language.value == "ru_RU":
				backstring = backstring.replace('Monday', 'Понедельник')
				backstring = backstring.replace('Tuesday', 'Вторник')
				backstring = backstring.replace('Wednesday', 'Среда')
				backstring = backstring.replace('Thursday', 'Четверг')
				backstring = backstring.replace('Friday', 'Пятница')
				backstring = backstring.replace('Saturday', 'Суббота')
				backstring = backstring.replace('Sunday', 'Воскресенье')
				backstring = backstring.replace('January', 'Январь')
				backstring = backstring.replace('February', 'Февраль')
				backstring = backstring.replace('March', 'Март')
				backstring = backstring.replace('April', 'Апрель')
				backstring = backstring.replace('May', 'Май')
				backstring = backstring.replace('June', 'Июнь')
				backstring = backstring.replace('July', 'Июль')
				backstring = backstring.replace('August', 'Август')
				backstring = backstring.replace('September', 'Сентябрь')
				backstring = backstring.replace('October', 'Октябрь')
				backstring = backstring.replace('November', 'Ноябрь')
				backstring = backstring.replace('December', 'Декабрь')
			return backstring
		elif self.type == self.FORMAT:
			spos = self.fmt_string.find('%')
			apos = self.fmt_string.find('%a')
			aapos = self.fmt_string.find('%A')
			bpos = self.fmt_string.find('%b')
			bbpos = self.fmt_string.find('%B')
			if spos > 0:
				s1 = self.fmt_string[:spos]
				s2 = strftime(self.fmt_string[spos:], t)
				backstring = str(s1+s2)
				if config.osd.language.value == "ru_RU":
					if apos > -1:
						backstring = backstring.replace('Mon', 'Пн')
						backstring = backstring.replace('Tue', 'Вт')
						backstring = backstring.replace('Wed', 'Ср')
						backstring = backstring.replace('Thu', 'Чт')
						backstring = backstring.replace('Fri', 'Пт')
						backstring = backstring.replace('Sat', 'Сб')
						backstring = backstring.replace('Sun', 'Вс')
					if aapos > -1:
						backstring = backstring.replace('Monday', 'Понедельник')
						backstring = backstring.replace('Tuesday', 'Вторник')
						backstring = backstring.replace('Wednesday', 'Среда')
						backstring = backstring.replace('Thursday', 'Четверг')
						backstring = backstring.replace('Friday', 'Пятница')
						backstring = backstring.replace('Saturday', 'Суббота')
						backstring = backstring.replace('Sunday', 'Воскресенье')
					if bpos > -1:
						backstring = backstring.replace('Jan', 'Янв')
						backstring = backstring.replace('Feb', 'Фев')
						backstring = backstring.replace('Mar', 'Март')
						backstring = backstring.replace('Apr', 'Апр')
						backstring = backstring.replace('May', 'Май')
						backstring = backstring.replace('June', 'Июнь')
						backstring = backstring.replace('July', 'Июль')
						backstring = backstring.replace('Aug', 'Авг')
						backstring = backstring.replace('Sept', 'Сен')
						backstring = backstring.replace('Oct', 'Окт')
						backstring = backstring.replace('Nov', 'Ноя')
						backstring = backstring.replace('Dec', 'Дек')
					if bbpos > -1:
						backstring = backstring.replace('January', 'Январь')
						backstring = backstring.replace('February', 'Февраль')
						backstring = backstring.replace('March', 'Март')
						backstring = backstring.replace('April', 'Апрель')
						backstring = backstring.replace('May', 'Май')
						backstring = backstring.replace('June', 'Июнь')
						backstring = backstring.replace('July', 'Июль')
						backstring = backstring.replace('August', 'Август')
						backstring = backstring.replace('September', 'Сентябрь')
						backstring = backstring.replace('October', 'Октябрь')
						backstring = backstring.replace('November', 'Ноябрь')
						backstring = backstring.replace('December', 'Декабрь')
				return backstring
			else:
				backstring = strftime(self.fmt_string, t)
				if config.osd.language.value == "ru_RU":
					if apos > -1:
						backstring = backstring.replace('Mon', 'Пн')
						backstring = backstring.replace('Tue', 'Вт')
						backstring = backstring.replace('Wed', 'Ср')
						backstring = backstring.replace('Thu', 'Чт')
						backstring = backstring.replace('Fri', 'Пт')
						backstring = backstring.replace('Sat', 'Сб')
						backstring = backstring.replace('Sun', 'Вс')
					if aapos > -1:
						backstring = backstring.replace('Monday', 'Понедельник')
						backstring = backstring.replace('Tuesday', 'Вторник')
						backstring = backstring.replace('Wednesday', 'Среда')
						backstring = backstring.replace('Thursday', 'Четверг')
						backstring = backstring.replace('Friday', 'Пятница')
						backstring = backstring.replace('Saturday', 'Суббота')
						backstring = backstring.replace('Sunday', 'Воскресенье')
					if bpos > -1:
						backstring = backstring.replace('Jan', 'Янв')
						backstring = backstring.replace('Feb', 'Фев')
						backstring = backstring.replace('Mar', 'Март')
						backstring = backstring.replace('Apr', 'Апр')
						backstring = backstring.replace('May', 'Май')
						backstring = backstring.replace('June', 'Июнь')
						backstring = backstring.replace('July', 'Июль')
						backstring = backstring.replace('Aug', 'Авг')
						backstring = backstring.replace('Sept', 'Сен')
						backstring = backstring.replace('Oct', 'Окт')
						backstring = backstring.replace('Nov', 'Ноя')
						backstring = backstring.replace('Dec', 'Дек')
					if bbpos > -1:
						backstring = backstring.replace('January', 'Январь')
						backstring = backstring.replace('February', 'Февраль')
						backstring = backstring.replace('March', 'Март')
						backstring = backstring.replace('April', 'Апрель')
						backstring = backstring.replace('May', 'Май')
						backstring = backstring.replace('June', 'Июнь')
						backstring = backstring.replace('July', 'Июль')
						backstring = backstring.replace('August', 'Август')
						backstring = backstring.replace('September', 'Сентябрь')
						backstring = backstring.replace('October', 'Октябрь')
						backstring = backstring.replace('November', 'Ноябрь')
						backstring = backstring.replace('December', 'Декабрь')
				return backstring
		else:
			return "???"

	text = property(getText)
